const buildState = ({ theme, color, border, bg }) => {
	return {
		'& > div:first-of-type': {
			border: `1px solid ${theme(border)}`,
			borderRight: 'none',
			borderRadius: `${theme('borderRadius.md')} 0 0 ${theme('borderRadius.md')}`,
			padding: '1rem',
			paddingRight: '.5rem',
			backgroundColor: theme(bg),
			'& > svg': {
				fontSize: '1.5rem',
				color: theme(color)
			}
		},
		'& > div:last-of-type': {
			width: '100%',
			border: `1px solid ${theme(border)}`,
			backgroundColor: theme(bg),
			borderLeft: 'none',
			padding: '1rem',
			paddingLeft: theme('spacing.1'),
			borderRadius: `0 ${theme('borderRadius.md')} ${theme('borderRadius.md')} 0`,
			display: 'flex',
			alignItems: 'center'
		}
	};
};

const message = (theme) => ({
	'.message': {
		width: '100%',
		display: 'flex',
		color: theme('colors.black'),
		borderRadius: theme('borderRadius.md'),
		backgroundColor: 'white',
		marginBottom: '2rem',
		'&--none': buildState({
			theme,
			color: 'colors.message.none.color',
			border: 'colors.message.none.border',
			bg: 'colors.message.none.background'
		}),
		'&--info': buildState({
			theme,
			color: 'colors.message.info.color',
			border: 'colors.message.info.border',
			bg: 'colors.message.info.background'
		}),
		'&--success': buildState({
			theme,
			color: 'colors.message.success.color',
			border: 'colors.message.success.border',
			bg: 'colors.message.success.background'
		}),
		'&--warning': buildState({
			theme,
			color: 'colors.message.warning.color',
			border: 'colors.message.warning.border',
			bg: 'colors.message.warning.background'
		}),
		'&--error': buildState({
			theme,
			color: 'colors.message.error.color',
			border: 'colors.message.error.border',
			bg: 'colors.message.error.background'
		})
	}
});

module.exports = ({ addComponents, theme }) => {
	addComponents(message(theme));
};

module.exports.message = message;
